# Отчёт по лабораторной работе №1

Выполнил: студент гр. ИСТбд-41 Моисеев Владислав.

Вариант программы 1: Формирует файл `/var/result/data.txt` из содержимого всех файлов каталога `/var/data`.

Вариант программы 2: Сохраняет сумму чисел из файла `/var/data/data.txt` в `/var/result/result.txt`.

## Создание приложений

Создадим 2 приложения.
Был выбран язык C# и технология .NET 7, потому что хочется.

Для создания обычных консольных приложений воспользуемся командами:

```sh
dotnet new console -o worker-1
dotnet new console -o worker-2
```

Согласно варианту программа 1 должна брать все файлы из папки `/var/data`, считывать оттуда строки и укладывать их в файл `/var/result/data.txt`.

[Исходный текст программы worker-1](worker-1/Program.cs)

Согласно варианту программа 2 должна брать строки из файла `/var/data/data.txt`, пытаться привести их к числам, а затем заниматься их сложением.
Затем результат вычислений копируется в файл `/var/result/result.txt`.

[Исходный текст программы worker-2](worker-2/Program.cs)

Дополнительно создан файл [.gitignore](.gitignore) для того, чтобы не закоммитить в git ничего лишнего.

## Настройка окружения

Для связи двух приложений воспользуемся следующей схемой:

1. Каталог `./data` должен быть примонтирован в каталог `/var/data` для программы 1.
   Оттуда будут браться исходные данные.
2. Каталог `./result-1` должен быть примонтирован в каталог `/var/result` для программы 2.
   Туда будут складываться промежуточные данные.
3. Каталог `./result-1` также должен быть примонтирован в каталог `/var/data` для программы 2.
   Оттуда будут браться промежуточные результаты.
4. Каталог `./result` должен быть примонтирован в каталог `/var/result` для программы 2.
   Туда будут складывать результаты финальной обработки.

Для каждой программы были созданы файлы Dockerfile ([программа 1](worker-1/Dockerfile), [программа 2](worker-1/Dockerfile)) с подробным описанием процесса сборки.

Был создан файл [docker-compose.yml](docker-compose.yml), в котором указан манифест для запуска распределённого приложения.

Дополнительно был создан файл [.dockerignore](.dockerignore) и дополнен [.gitignore](.gitignore), чтобы исключить для сборки и коммита всё лишнее.

## Сборка и запуск

В каталог `./data` помещены 2 файла.
Сумма чисел в первом - 10, во втором - 40.

Для запуска приложения необходимо ввести команду `docker compose up ---build`.

Результат запуска после сборки:

```
[+] Running 2/0
 - Container lab_2-worker-1-1  Created
 - Container lab_2-worker-2-1  Created
Attaching to lab_2-worker-1-1, lab_2-worker-2-1
lab_2-worker-1-1  | Начало обработки файла /var/data/another data.txt
lab_2-worker-1-1  | Начало обработки файла /var/data/data.txt
lab_2-worker-1-1 exited with code 0
lab_2-worker-2-1  | Чисел для обработки: 8
lab_2-worker-2-1 exited with code 0
```

В результате в каталоге `./result` создался файл `result.txt` с содержимым `50`, что соответствует входным данным.

Изменение значений в файлах из каталога `./data` также изменяет содержимое в файлах из каталогов `./result-1` и `./result`.
